/*
	Speccy Tracks Remake!
	
	Kite Thinker by Spectra
	- For maps that utilise hanggliding
	- real fuckin buggy rn lol
*/

// Mobj
freeslot("MT_RACERHANGGLIDER", "S_RACERHANGGLIDER")
mobjinfo[MT_RACERHANGGLIDER] = {
	spawnstate = S_THOK,
	width = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOGRAVITY,
}

addHook("MobjThinker", function(mo)
	if not mo or not mo.valid then return end
	mo.sprite = SPR_KINF
	mo.frame = C

	mo.tics = 999
	mo.momz = 0

	if mo.attach and mo.attach.valid
		mo.target = mo.attach
		
		if mo.attach.player
			mo.color = mo.attach.player.skincolor
		else
			mo.color = mo.attach.color
		end

		local mo2 = mo.attach
		P_TeleportMove(mo, mo2.x, mo2.y, mo2.z + mo2.height)

		if mo2.gliding
			mo.destscale = 3*mo2.scale/2
			if not S_SoundPlaying(mo, sfx_s3kcel) then S_StartSound(mo, sfx_s3kcel) end
		else
			mo.destscale = 1
			if not S_SoundPlaying(mo, sfx_s3kcel) then S_StopSound(mo) end
		end
	end
end, MT_RACERHANGGLIDER)

// Linedef Executors
addHook("LinedefExecute", function(line, mo, sect)
	local lineangle = R_PointToAngle2(line.v1.x, line.v1.y, line.v2.x, line.v2.y)

	if mo and mo.valid and mo.player then
		mo.gliding = true
		mo.glideangle = lineangle
		mo.glidespeed = mo.player.speed
		mo.glideuptimer = 0

		P_SetObjectMomZ(mo, 10*FRACUNIT)

		mo.upglide = 35
		mo.angle = lineangle
	end
end, "GLIDE")

// ThinkFrames
addHook("ThinkFrame", do
	for p in players.iterate do
		if not p.mo or not p.mo.valid then continue end

		p.mo.glideangle = $ or 0 // The angle of gliding
		p.mo.glidespeed = $ or 0 // The speed of gliding
		p.mo.upglide = $ or 0 // The start of gliding
		p.mo.glideuptimer = $ or 0 // The time the player can glide up for

		// Now comes the code
		if not p.mo.racerKite or not p.mo.racerKite.valid then
			p.mo.racerKite = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_RACERHANGGLIDER)
			p.mo.racerKite.scale = 1
			p.mo.racerKite.angle = p.mo.glideangle or 0
			p.mo.racerKite.color = p.skincolor
			p.mo.racerKite.attach = p.mo
		end

		if p.mo.gliding then
			p.mo.flags = $|MF_NOGRAVITY
			if p.mo.angle >= (p.mo.glideangle + 20*ANG1)
				P_Thrust(p.mo, p.mo.angle+ANGLE_90, 6*FRACUNIT)
				p.mo.angle = (p.mo.glideangle + 10*ANG1)
			elseif p.mo.angle <= (p.mo.glideangle - 20*ANG1)
				P_Thrust(p.mo, p.mo.angle-ANGLE_90, 6*FRACUNIT)
				p.mo.angle = (p.mo.glideangle - 10*ANG1)
			end	

			P_InstaThrust(p.mo, p.mo.angle, p.mo.glidespeed)

			if p.mo.glidespeed < 30*FRACUNIT
				p.mo.glidespeed = $ + FRACUNIT/4
			elseif p.mo.glidespeed > 50*FRACUNIT 
			and not p.kartstuff[k_driftboost]
				p.mo.glidespeed = $ - FRACUNIT/4
			end

			if p.mo.upglide > 0
				p.mo.momz = 6*FRACUNIT
				p.mo.upglide = $ - 2
			else
				if (p.cmd.buttons & BT_BACKWARD) and (p.mo.glideuptimer < 35) // Holding Aim Backward
					P_SetObjectMomZ(p.mo, FRACUNIT/3, true)
					p.mo.glideuptimer = max(35, $+1)
				elseif (p.cmd.buttons & BT_FORWARD) // Holding Aim Forward
					p.mo.momz = $-(FRACUNIT/2)
					p.mo.glideuptimer = min(0, $-2)
				else
					p.mo.momz = $-(FRACUNIT/8)
					p.mo.glideuptimer = min(0, $-1)
				end
			end

			// End Gliding
			if (P_IsObjectOnGround(p.mo) or P_PlayerInPain(p) 
			or p.mo.eflags & MFE_JUSTBOUNCEDWALL or p.speed == 0)
			and p.mo.upglide <= 0
				p.firstglide = true
				p.mo.gliding = nil
				p.mo.glidespeed = 0
				p.mo.flags = $ & ~MF_NOGRAVITY
			end
		end
	end
end)